<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\DashboardService;
use FM\Traits\TResponse;

class DashboardController extends FMCrud {

    use TResponse;
    protected $DashboardService;

    public function __construct($crudService, $environment, DashboardService $DashboardService) {
        parent::__construct($crudService, $environment);
        $this->DashboardService = $DashboardService;
    }

    public function dataBaseChartPie(DTO\Request $request, DTO\Response $response) {

        $dbcp = $this->DashboardService->dataBaseChartPie();
        $dtsVal = new DataSet('dbChartp', $dbcp);
        $response->addDataSet($dtsVal);
    }

    public function dataBaseChartBar(DTO\Request $request, DTO\Response $response) {
       
        $dbcb = $this->DashboardService->dataBaseChartBar();
        $dtsVal = new DataSet('dbChartb', $dbcb);
        $response->addDataSet($dtsVal);
    }

    public function tarefasFinalizadas(Request $request, Response $response) {
        try {
                $data = $this->DashboardService->tarefasFinalizadas();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function tarefasAtrasadas(Request $request, Response $response) {
        try {
                $data = $this->DashboardService->tarefasAtrasadas();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function tarefasConcluidas(Request $request, Response $response) {
        try {
                $data = $this->DashboardService->tarefasConcluidas();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

    public function ultimasTarefasRealizadas(Request $request, Response $response) {
        try {
                $data = $this->DashboardService->ultimasTarefasRealizadas();
                $this->sendResponse($data, 200);
            } catch (Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }

}
?>