<?php
namespace FM\Service;

use FM\Factory\DashboardFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use FM\Service\FuncionariosHierarqService;

class DashboardService {

    protected $DashboardFactory;
    protected $FuncionariosHierarqService;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, DashboardFactory $DashboardFactory, FuncionariosHierarqService $FuncionariosHierarqService, Environment $Environment, NewCode $newCode) {
        $this->connection                   = $entityManager->getConnection();
        $this->DashboardFactory             = $DashboardFactory;
        $this->FuncionariosHierarqService   = $FuncionariosHierarqService;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function dataBaseChartPie() {
    
        $cdOperador = $this->Environment->getCdOperador(); 
        $retorno  = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdOperador); 

        return  $this->DashboardFactory->dataBaseChartPie($cdOperador);

    }

    public function dataBaseChartBar() {

        $cdOperador = $this->Environment->getCdOperador(); 
        $retorno  = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdOperador); 

        return $this->DashboardFactory->dataBaseChartBar($cdOperador);
    }


    public function tarefasFinalizadas() {
      
        $cdOperador = $this->Environment->getCdOperador(); 
        $retorno  = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdOperador); 

        return $this->DashboardFactory->tarefasFinalizadas($retorno);
    }

    public function tarefasAtrasadas() {
      
        $cdOperador = $this->Environment->getCdOperador(); 
        $retorno  = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdOperador); 

        return $this->DashboardFactory->tarefasAtrasadas($retorno);
    }

    public function tarefasConcluidas() {
      
        $cdOperador = $this->Environment->getCdOperador(); 
        $retorno  = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdOperador); 

        return $this->DashboardFactory->tarefasConcluidas($retorno);
    }

    public function ultimasTarefasRealizadas() {
      
        $cdOperador = $this->Environment->getCdOperador(); 
        $retorno  = $this->FuncionariosHierarqService->montarHierarquiaOperadores($cdOperador); 

        return $this->DashboardFactory->ultimasTarefasRealizadas($retorno);
    }

}