IF EXISTS(SELECT NAME FROM SYSOBJECTS
           WHERE NAME = 'APAGA_PARAM_CTBL'
             AND TYPE = 'P')
  DROP PROCEDURE APAGA_PARAM_CTBL
GO

CREATE PROCEDURE APAGA_PARAM_CTBL(
  @P_CDTIPOOPER  VARCHAR(500),
  @P_CDOPERADOR  VARCHAR(12),
  @P_CDFILIAL    VARCHAR(04))
AS
   DECLARE @V_CDITEMPARACTB VARCHAR(05);
BEGIN
   DECLARE C_ITEMEXCLUCTB CURSOR FOR
      SELECT CDITEMPARACTB
         FROM ITEMPARACTB
        WHERE CHARINDEX(CDITEMPARACTB, @P_CDTIPOOPER) > 0
        ORDER BY CDITEMPARACTB;

      OPEN C_ITEMEXCLUCTB;
      FETCH NEXT FROM C_ITEMEXCLUCTB INTO @V_CDITEMPARACTB;
      WHILE @@FETCH_STATUS = 0 BEGIN
         IF @V_CDITEMPARACTB = '00001' BEGIN -- Tipo de Retirada
            UPDATE TIPORETI
               SET CDCONTCTBL  = NULL,
                   IDCONTABCMV = 'N',
                   CDHISTPADR  = NULL;

         END
         ELSE IF @V_CDITEMPARACTB = '00002' BEGIN  -- Tipo de Operao - Entrada
            UPDATE TIPOOPERAC
               SET CDCONTFORCLI = NULL,
                   CDCONTPROD   = NULL,
                   CDHISTPADR   = NULL,
                   IDCOAVRIMPVRPROD = 'N',
                   CDCTBLTPOPERCMV = NULL,
                   CDREFLOTECTBTO  = NULL,
                   IDDTCONTAB      = NULL
             WHERE IDENTRSAIDOP = 'E';
         END
         ELSE IF @V_CDITEMPARACTB = '00003' BEGIN  -- Tipo de Operao - Sada
            UPDATE TIPOOPERAC
               SET CDCONTFORCLI = NULL,
                   CDCONTPROD   = NULL,
                   CDHISTPADR   = NULL,
                   IDCOAVRIMPVRPROD = 'N',
                   CDCTBLTPOPERCMV = NULL,
                   CDREFLOTECTBTO  = NULL,
                   IDDTCONTAB      = NULL
             WHERE IDENTRSAIDOP = 'S';
          END
          ELSE IF @V_CDITEMPARACTB = '00004' BEGIN -- TIPO DE DBITO BANCRIO
             UPDATE TPDEBIBANC
                SET CDCONTCTBL   = NULL,
                    CDHISTPADR   = NULL,
                    CDREFLOTECTBTDB = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00005' BEGIN -- TIPO DE CRDITO BANCRIO
             UPDATE TPCREDBANC
                SET CDHISTPADR   = NULL,
                    CDCONTCTBL   = NULL,
                    IDCTBLCRBANC = 'S',
                    CDREFLOTECTBTCB = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00006' BEGIN -- Tipo de conta a receber
             UPDATE TIPOCTRECEBER
                SET CDCONTCTBL  = NULL,
                    CDREFLOTECTBTR = NULL,
                    CDHISTPADR     = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00007' BEGIN -- Tipo de conta a pagar
             UPDATE TIPOCTPAGAR
                SET CDCONTCTBL = NULL,
                    CDHISTPADR = NULL,
                    CDREFLOTECTBTP = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00008' BEGIN -- Tipo de baixa a receber
             UPDATE TIPOBAIXAREC
                SET CDHISTPADR = NULL,
                    CDREFLOTECTBTBR = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00009' BEGIN -- Tipo de baixa a pagar
             UPDATE TIPOBAIXAPAG
                SET CDHISTPADR = NULL,
                    CDREFLOTECTBTBP = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00010' BEGIN -- Tipo de ajuste de conta a receber
             UPDATE TIPOAJRECEBER
                SET CDHISTPADR      = NULL,
                    CDCONTCTBL      = NULL,
                    CDREFLOTECTBTAR = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00011' BEGIN -- Tipo de ajuste de conta a pagar
             UPDATE TIPOAJPAGAR
                SET CDHISTPADR = NULL,
                    CDCONTCTBL = NULL,
                    CDREFLOTECTBTAP = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00012' BEGIN -- Produto
             UPDATE PRODUTO
                SET CDCTBLENTRPR = NULL,
                    CDCTBLSAIDPR = NULL,
                    CDCTBLPRODPR = NULL,
                    CDCTBLCPROPR = NULL,
                    CDCTBLAJUSPR = NULL,
                    CDCTBLIMPLPR = NULL,
                    CDCTBLPRACPR = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00013' BEGIN -- Padro
             UPDATE PARAMCTBL
                SET CDCONTDIFE    = NULL,
                    CDCTBLPERDPA  = NULL,
                    CDCONTDITEN   = NULL,
                    CDCONTDITSA   = NULL,
                    CDREFLOTECTBL = NULL,
                    CDCONTFORN    = NULL,
                    CDCONTCLIE    = NULL;

             UPDATE PARAMEMPRESA
                SET CDCONFORNEM   = NULL,
                    CDCONCLIEEM   = NULL,
                    CDCONTDIFEEM  = NULL,
                    CDCTBLPERDEM  = NULL;

             UPDATE PARAMFILIAL
                SET CDCONCLIEFI   = NULL,
                    CDCONFORNFI   = NULL,
                    CDCONTDIFEFI  = NULL,
                    CDCTBLPERDFI  = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00014' BEGIN -- Integrao contbil
             UPDATE PARAMCTBL
                SET DTINTCTBBCO   = NULL,
                    DTINTCTBPAG   = NULL,
                    DTINTCTBREC   = NULL,
                    DTINTCTBDFE   = NULL,
                    DTINTCTBDFS   = NULL,
                    DTINTCTBEXP   = NULL,
                    DTINTCTBEST   = NULL,
                    DTINTCTBFAC   = NULL,
                    DTINTCTBFAS   = NULL,
                    DTINTCTBFIS   = NULL;

          END
          ELSE IF @V_CDITEMPARACTB = '00015' BEGIN -- Imposto
             UPDATE IMPOSTO
                SET CDCCTBLDESP = NULL,
                    CDCCTBLPASS = NULL,
                    CDCCTBLATIV = NULL,
                    CDCCTBLDADM = NULL;

             UPDATE CCTBIMPFORN
                SET CDCCTBATIVIF = NULL,
                    CDCCTBDADMIF = NULL,
                    CDCCTBPASSIF = NULL,
                    CDCCTBDESPIF = NULL
              WHERE IDTPIJURIMPO = 'J';

             UPDATE CCTBIMPFORN
                SET CDCCTBATIVIF = NULL,
                    CDCCTBDADMIF = NULL,
                    CDCCTBPASSIF = NULL,
                    CDCCTBDESPIF = NULL
              WHERE IDTPIJURIMPO = 'F';

             UPDATE CCTBIMPFORN
                SET CDCCTBATIVIF = NULL,
                    CDCCTBDADMIF = NULL,
                    CDCCTBPASSIF = NULL,
                    CDCCTBDESPIF = NULL
              WHERE IDTPIJURIMPO = 'I';

             UPDATE CCTBIMPFORN
                SET CDCCTBATIVIF = NULL,
                    CDCCTBDADMIF = NULL,
                    CDCCTBPASSIF = NULL,
                    CDCCTBDESPIF = NULL
              WHERE IDTPIJURIMPO = 'O';

             UPDATE CTBIMPTPOPER
                SET CDCCTBATIVTO = NULL,
                    CDCCTBDADMTO = NULL,
                    CDCCTBPASSTO = NULL,
                    CDCCTBDESPTO = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00016' BEGIN -- Estoque
             UPDATE PARAMESTOQUE
                SET CDHISTPADRETEST = NULL,
                    CDHISTPADRETPRO = NULL,
                    CDHISTPADSAIEST = NULL,
                    CDHISTPADRAJIMP = NULL,
                    CDREFLOTECTBRET = NULL,
                    CDREFLOTECTBPRO = NULL,
                    CDREFLOTECTBSAI = NULL,
                    CDREFLOTECTBIMP = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00017' BEGIN -- Encargo
             UPDATE ENCARGO
                SET CDCTBLENTREN = NULL,
                    CDCTBLSAIDEN = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00018' BEGIN -- Fornecedor
             UPDATE FORNECEDOR
                SET CDCONTCTBL   = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00019' BEGIN -- Filial
             UPDATE FILIAL
                SET CDCONTCTBL = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00020' BEGIN -- Conta corrente
             UPDATE CONTCORR
                SET CDCONTCTBL = NULL;
          END
          ELSE IF @V_CDITEMPARACTB = '00021' BEGIN -- Cliente
             UPDATE CLIENTE
                SET CDCONTCTBL = NULL;

          END;

          INSERT INTO LOGEXCLITPARCTB
             (CDITEMPARACTB, DTEXCLITEM, CDFILIAL, CDOPERINCLUSAO)
          VALUES
             (@V_CDITEMPARACTB, GETDATE(), @P_CDFILIAL, @P_CDOPERADOR);

         FETCH NEXT FROM C_ITEMEXCLUCTB INTO @V_CDITEMPARACTB;
      END;
      CLOSE C_ITEMEXCLUCTB;
      DEALLOCATE C_ITEMEXCLUCTB;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'APAGA_PARAM_CTBL','5.42.000';
GO